#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

int chardelay=2000;
int tdelayOn=1200;
int tdelayOff=1200;

#define LOGO16_GLCD_HEIGHT 16 
#define LOGO16_GLCD_WIDTH  16 
static const unsigned char PROGMEM logo16_glcd_bmp[] =
{ B00000000, B11000000,
  B00000001, B11000000,
  B00000001, B11000000,
  B00000011, B11100000,
  B11110011, B11100000,
  B11111110, B11111000,
  B01111110, B11111111,
  B00110011, B10011111,
  B00011111, B11111100,
  B00001101, B01110000,
  B00011011, B10100000,
  B00111111, B11100000,
  B00111111, B11110000,
  B01111100, B11110000,
  B01110000, B01110000,
  B00000000, B00110000 };

// the setup function runs once when you press reset or power the board
void setup() {
 // Serial.begin(9600);
 
 // LCD setup
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3D (for the 128x64)
  
  
 ///// display.ssd1306_command(0xA1);
  
  // Clear the buffer.
  display.clearDisplay();
display.display();  
  


 
  // initialize digital pins as output.
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);  
  pinMode(4, OUTPUT);    
  pinMode(5, OUTPUT);  
  pinMode(6, OUTPUT);     
  pinMode(7, OUTPUT);  
  pinMode(8, OUTPUT);     
  pinMode(9, OUTPUT);    
  pinMode(A5, OUTPUT);    
  pinMode(10, OUTPUT);     
  pinMode(11, OUTPUT);   
  pinMode(12, OUTPUT);     
  pinMode(13, OUTPUT);   
  pinMode(A0, OUTPUT);
    pinMode(A1, OUTPUT);

              digitalWrite(8, HIGH); //ic1
           //   digitalWrite(5, HIGH); //ic2
              digitalWrite(13, HIGH); // ic3
              digitalWrite(2, HIGH);  // pwma&b
              
 
display.setRotation(1);
 

}




// PUSH (up)  
void On_off(int pin1,int pin2, int delayOn)
{          //   lampeggio();
              digitalWrite(pin1, HIGH); 
              digitalWrite(pin2, LOW); 
              delay(delayOn); 
              digitalWrite(pin1, LOW); 
              digitalWrite(pin2, LOW);
              delay(100); 
  }  
  
// PULL (down)
void Off_on(int pin1,int pin2, int delayOn)
{       //      lampeggio();
        //      lampeggio();
              digitalWrite(pin1, LOW); 
              digitalWrite(pin2, HIGH); 
              delay(delayOn); 
              digitalWrite(pin1, LOW); 
              digitalWrite(pin2, LOW);
              delay(100); 
  }   


 




  



// the loop function runs over and over again forever
void loop() {
/*
      // -------- 1 --------------
  display.clearDisplay();   
//   display.drawCircle(20,20, 8, WHITE);
//   display.fillCircle(60,20,8, WHITE);
//   display.drawCircle(40,20, 8, WHITE);
//   display.drawCircle(20,40, 8, WHITE);
//   display.drawCircle(40,40, 8, WHITE);   
//   display.drawCircle(60,40, 8, WHITE); 
    display.drawCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.drawCircle(20,40, 8, WHITE);
   display.drawCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(20,80);
  display.println(" A ");   
//  display.drawBitmap(80, 20,  logo16_glcd_bmp, 16, 16, 1);
  display.display();     
  
    // Character test pin 1       
    On_off(9,10,100);//su pin 1
    delay (2000); 
    Off_on(9,10,200); //giù pin 1
    delay (2000);

    
    
  // -------- Pin 2 --------------
  display.clearDisplay();
   display.fillCircle(60,40, 8, WHITE);
   display.drawCircle(20,20,8, WHITE);
   display.drawCircle(40,20, 8, WHITE);
   display.drawCircle(20,40, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(60,20, 8, WHITE);   
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(80,20);
  display.println("Pin 2");   
  display.display();  
  
  // Character test pin 2
   On_off(A0,A1,150);//su  pin 2       
   delay (2000);   
   Off_on(A0,A1,150); //giu pin 2
   delay (2000);


  // -------- Pin 3 --------------
  display.clearDisplay();   
   display.drawCircle(20,20, 8, WHITE);
   display.fillCircle(40,20,8, WHITE);
   display.drawCircle(60,20, 8, WHITE);
   display.drawCircle(20,40, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(60,40, 8, WHITE);   
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(80,20);
  display.println("Pin 3");   
  display.display();     
  
    // Character test pin3       
    On_off(11,12,150);//su pin 3
    delay (2000);  
    Off_on(11,12,150); //giu pin 3
    delay (2000);

  
 
 
   // -------- Pin 6 --------------
  display.clearDisplay();   
   display.fillCircle(20,40, 8, WHITE);
   display.drawCircle(40,20,8, WHITE);
   display.drawCircle(60,20, 8, WHITE);
   display.drawCircle(20,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(60,40, 8, WHITE);   
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(80,20);
  display.println("Pin 6");   
  display.display();     
  
    // Character test pin6      
    Off_on(6,7,150); //su pin 5
    delay (2000);
    On_off(6,7,150);//giù pin 5
    delay (2000);
    

   delay (2000);
 
// tutti giù
    Off_on(9,10,200); //giù pin 1
    delay (300);
    Off_on(A0,A1,150); //giu pin 2
    delay (300);
    Off_on(11,12,150); //giu pin 3
    delay (300);  
    On_off(6,7,150);//giù pin 5
    delay (300);  */

/*
//  ---- A------
delay (3000); 

  display.clearDisplay();   
     display.drawCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.drawCircle(20,40, 8, WHITE);
   display.drawCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" A ");  
   display.display(); 
  

   
   // prova
              digitalWrite(A0, LOW); 
              digitalWrite(A1, HIGH);
              
              digitalWrite(9, HIGH); 
              digitalWrite(10, LOW); 
              
              digitalWrite(A0, LOW); 
              digitalWrite(A1, HIGH);
              
              delay(100); 
              digitalWrite(9, LOW); 
              digitalWrite(10, LOW);
              digitalWrite(A0, LOW); 
              digitalWrite(A1, LOW);
              delay(3000); 
   // fine prova
   
   // giù e spento tutto 
    display.clearDisplay();  
    display.display();    
    Off_on(9,10,200); //giù pin 1
    delay (2000);

// ------- B --------------

    display.drawCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.fillCircle(20,40, 8, WHITE);
   display.drawCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" B ");   
  display.display();  
  
  // Character test pin 2
  

           
                On_off(11,12,150);//su pin 3
    delay (50);
              delay(50);    
    // muove pin     
    On_off(9,10,100);//su pin 1
    delay (150); 
   Off_on(A0,A1,250); //giu pin 2
   delay (3000);      


   // giù e spento tutto 
    display.clearDisplay(); 
   display.display();    
    Off_on(9,10,200); //giù pin 1
    delay (50);
    Off_on(11,12,150);//su pin 3
   delay (2000);
   
   
   // ------- C --------------

    display.drawCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.drawCircle(20,40, 8, WHITE);
   display.fillCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" C ");   
  display.display();  
  
  // Character test pin 2
   On_off(A0,A1,150);//su  pin 2       
   delay (50);   
    // muove pin     
    On_off(9,10,100);//su pin 1
    delay (3000); 
  // On_off(11,12,150);//su pin 3
  //  delay (3000);  



   // giù e spento tutto 
    display.clearDisplay(); 
   display.display();    
    Off_on(9,10,200); //giù pin 1
    delay (50);
   Off_on(A0,A1,250); //giu pin 2
   delay (50);
 //      Off_on(11,12,150); //giu pin 3
 //   delay (2000);    
 
 
 
  // ------- F --------------

    display.drawCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.fillCircle(20,40, 8, WHITE);
   display.fillCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" F ");   
  display.display();  
  
  
                On_off(11,12,150);//su pin 3
    delay (50);
              delay(50);    
    // muove pin     
    On_off(9,10,100);//su pin 1
    delay (150); 
   On_off(A0,A1,250); //giu pin 2
   delay (3000);    

  // giù e spento tutto 
    display.clearDisplay(); 
   display.display();    
    Off_on(9,10,200); //giù pin 1
    delay (50);
   Off_on(A0,A1,250); //giu pin 2
   delay (50);
       Off_on(11,12,150); //giu pin 3
    delay (2000); 

  
  
 // ------- I --------------

    display.drawCircle(20,60, 8, WHITE);
   display.drawCircle(20,20,8, WHITE);
   display.fillCircle(20,40, 8, WHITE);
   display.fillCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" I ");   
  display.display();  
  
  
                On_off(11,12,150);//su pin 3
    delay (50);
              delay(50);    
    // muove pin     
//    On_off(9,10,100);//su pin 1
//    delay (150); 
   On_off(A0,A1,250); //giu pin 2
   delay (3000);    

  // giù e spento tutto 
    display.clearDisplay(); 
   display.display();    
 //   Off_on(9,10,200); //giù pin 1
//    delay (50);
   Off_on(A0,A1,250); //giu pin 2
   delay (50);
       Off_on(11,12,150); //giu pin 3
    delay (2000);   
    
*/

// ------------------------- test v2 -----------------------------------

 // ------- F --------------
    delay (3000);

    display.drawCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.fillCircle(20,40, 8, WHITE);
   display.fillCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" F ");   
  display.display();  
  
  
   On_off(11,12,150);//su pin 3
     delay(50);    
    // muove pin     
    On_off(9,10,100);//su pin 1
    delay (150); 
   On_off(A0,A1,250); //giu pin 2
   delay (3000);    

  // giù e spento tutto 
    Off_on(9,10,200); //giù pin 1
     delay (100); 

  
  
 // ------- I --------------
  display.clearDisplay(); 
    display.drawCircle(20,60, 8, WHITE);
   display.drawCircle(20,20,8, WHITE);
   display.fillCircle(20,40, 8, WHITE);
   display.fillCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" I ");   
  display.display();  
  
  
                On_off(11,12,150);//su pin 3
    delay (3000);
    
    // muove pin     
//    On_off(9,10,100);//su pin 1
//    delay (150); 
   On_off(A0,A1,250); //giu pin 2
   delay (50);    
    On_off(9,10,200); //giù pin 1
    delay (50);
   Off_on(A0,A1,250); //giu pin 2
   delay (100);


// L 
  display.clearDisplay();
  display.fillCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.fillCircle(20,40, 8, WHITE);
   display.drawCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" L ");   
  display.display();  
 
 
     //pin basso
     digitalWrite(5, HIGH); //ic2
      delay (150);    
     digitalWrite(5, LOW); //ic2  
     
  // Character test pin 2
       On_off(11,12,150);//su pin 3
              delay(100);    
    // muove pin     
    On_off(9,10,100);//su pin 1
    delay (150); 
   Off_on(A0,A1,250); //giu pin 2
   delay (3000);       

 
     
     
 // M
   display.clearDisplay();
   display.fillCircle(20,60, 8, WHITE);
   display.fillCircle(20,20,8, WHITE);
   display.drawCircle(20,40, 8, WHITE);
   display.fillCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);   
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" M ");   
  display.display();  
  
  // Character test pin 2
   On_off(A0,A1,150);//su  pin 2       
   delay (50);   
    // muove pin     
    On_off(9,10,100);//su pin 1
    delay (150); 
   Off_on(11,12,150);//su pin 3
    delay (3000);  
  
  
   display.clearDisplay();    
  
  // S
 
  display.clearDisplay();
display.fillCircle(20,60, 8, WHITE);
   display.drawCircle(20,20,8, WHITE);
   display.fillCircle(20,40, 8, WHITE);
   display.fillCircle(40,20, 8, WHITE);
   display.drawCircle(40,40, 8, WHITE);   
   display.drawCircle(40,60, 8, WHITE);    
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(8,80);
  display.println(" S ");   
  display.display();  
  
  // Character test pin 2
       On_off(11,12,150);//su pin 3
              delay(100);    
    // muove pin     
    Off_on(9,10,100);//giù pin 1
    delay (150); 
   On_off(A0,A1,250); //su pin 2
   delay (4000);       
 
display.clearDisplay(); 
       
       
         
       
         
         
         
         
         
}
